#!/usr/bin/perl

use Net::SMTP;

($MIN, $HOUR ,$DAY, $MONTH, $YEAR) = (localtime)[1,2,3,4,5];$MONTH=$MONTH+1;$YEAR=$YEAR+1900;
    
open F, "</usr/local/squidlog3/prog/squidlog3.conf";@CNF=<F>;close F;for ($i=0;$i<@CNF;$i++){ ($k,$v)=split('\s+',$CNF[$i]);$CONF{$k}=$v};

exit if $CONF{'passfile'} eq '';
exit if $CONF{'logfile'} eq '';
exit if $CONF{'limitfile'} eq '';
exit if $CONF{'traffile'} eq '';
exit if $CONF{'logprog'} eq '';
exit if $CONF{'userfile'} eq '';

sub SendMail
{
 if ($k ne ''){
 open F,"<$CONF{'userfile'}";
 while (<F>)
 {
  ($u,$fio,$email)=(split('#'))[0,1,2];
  if ($u eq $k) {last};
  $fio='';$email='';
 };
 close F;
 chomp($email);
 if ($email ne ''){
 $l=sprintf("%.2f",$limhash{$k});
 $t=sprintf("%.2f",$hash{$k}/1024/1024);
 	
 my $smtp = Net::SMTP->new("localhost");
 $smtp->mail($CONF{'adminmail'});
 $smtp->to($email);
 $smtp->data();
 $smtp->datasend("To: $email\n");
 $smtp->datasend("Subject: INTERNET\n");
 $smtp->datasend("Content-Type: text/html; charset=koi8-r\n");
 $smtp->datasend("\n");
	
 $mailmes = qq {

<html>
<head>
<title>-</title>
<meta http-equiv="Content-Type" content="text/html; charset=koi8-r">
</head>
<body>
<table width="555" border="0" bordercolor="#CCFF99">
  <tr>
    <td colspan="2" bgcolor="#99CC66"><div align="center"><h3>$fio</h3></div></td>
  </tr>
  <tr bgcolor="#CCFF99">
    <td colspan="2">
	   , ..   .<br>
	      .
    </td>
  </tr>
  <tr bgcolor="#CCFF99">
    <td><b> (/)</b></td>
    <td>$l</td>
  </tr>
  <tr bgcolor="#CCFF99">
    <td><b> ()</b></td>
    <td>$t</td>
  </tr>
  <tr bgcolor="#CCFF99">
    <td colspan="2"><div align="center"><small><b>$HOUR:$MIN  $DAY.$MONTH.$YEAR</b></small></div></td>
  </tr>
</table>
</body>
</html>
 };
	       
 $smtp->datasend("$mailmes");
 $smtp->dataend();
 $smtp->quit;
 print FLP "$YEAR.$MONTH.$DAY $HOUR:$MIN $k\tMAIL SEND\n";
 };};
};
		  					     

`cat $CONF{'logfile'} >> $CONF{'logfile'}.bu`;
open FLP,">>$CONF{'logprog'}";

#Load squid log
open FLOG,"<$CONF{'logfile'}";@LOG=<FLOG>;close FLOG;
open FLOG,">$CONF{'logfile'}";print FLOG "";close FLOG;

#Load traffik
#$hash{} -  
#$limhash{} - 
#$limphash{} -  
open FTRA,"<$CONF{'traffile'}";@TRA=<FTRA>;close FTRA;open FLIM,"<$CONF{'limitfile'}";@LIM=<FLIM>;close FLIM;
for ($i=0;$i<@TRA;$i++){ ($k,$v)=split('\s+',$TRA[$i]);$hash{$k}=$v};
for ($i=0;$i<@LIM;$i++){ ($k,$v)=split('\s+',$LIM[$i]);$limhash{$k}=$v};
#limit plus
open FLIM,"<$CONF{'limitpfile'}";@LIM=<FLIM>;close FLIM;
for ($i=0;$i<@LIM;$i++){ ($k,$v)=split('\s+',$LIM[$i]);$limphash{$k}=$v};

#Squid log parse
for ($i=0;$i<@LOG;$i++)
{
  ($tmp,$m,$k,$v)=(split('\s+',$LOG[$i]))[3,5,7,4];
  @sc = split('\/',$tmp);$status = $sc[0];$code = $sc[1];
  if (($m ne 'PUT')&&($k ne '-')&&($code ne '400')&&($code ne '404')&&($status ne 'TCP_DENIED')) { $hash{$k}=$hash{$k}+$v };
};

#on|off squid user
$flg=0;
open FOFF,"<$CONF{'passfile'}";@OFF=<FOFF>;close FOFF;
for ($i=0;$i<@OFF;$i++) {($k,$v)=split(':',$OFF[$i]);chomp($v);$offhash{$k}=$v};
while (($k,$v)=each %limhash){
 if ((($v+$limphash{$k})*1048576) <= $hash{$k}) {
  if (substr($offhash{$k},0,1) eq '*')  {   $offhash{$k}=$offhash{$k};  }
  else  {$flg=1;$offhash{$k}='*'.$offhash{$k};print FLP "$YEAR.$MONTH.$DAY $HOUR:$MIN $k\tOFF Squid\n";&SendMail; };  }
 else {
  if (substr($offhash{$k},0,1) ne '*')  {   $offhash{$k}=$offhash{$k};  }
  else  {$flg=1;substr($offhash{$k},0,1)='';   $offhash{$k}=$offhash{$k};print FLP "$YEAR.$MONTH.$DAY $HOUR:$MIN $k\tON Squid\n";  }; 
 };
};
if ($flg) {open FOFF,">$CONF{'passfile'}";while (($k,$v)=each %offhash) {print FOFF "$k:$v\n"};close FOFF;};

#Write traffik
open FTRA,">$CONF{'traffile'}";while (($k,$v)=each %hash) {print FTRA "$k\t$v\n"};close FTRA;
close FLP;
exit 0;
